config/urls.py
from django.contrib import admin
from django.urls import path,include
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('sns_integration.urls')),
]+ static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

sns_integration/urls.py
from django.urls import path
from django.urls.conf import re_path
from . import views as v
from django.contrib.auth.views import LoginView, LogoutView

urlpatterns = [
    path('', v.SearchedRedirectView.as_view()),
    path('index/', v.index, name="index"),
    path('register/intro', v.register_intro, name="register_intro"),
    path('register/info/step/1', v.register_info1, name="register_info1"),
    path('register/info/step/2', v.register_info2, name="register_info2"),
    path('register/info/step/3', v.register_info3, name="register_info3"),
    path('register/relative', v.relative_info, name="relative_info"),
    path('register/relative/<int:pk>/photo', v.relative_photo, name="relative_photo"),
    path('register/relative/<int:pk>/sns', v.relative_sns, name="relative_sns"),
    path('home/', v.home, name="home"),
    path('home/filter/', v.filter, name="filter"),
    re_path(r'^home/filter/=(?P<relatives>(?:\d+,*)+)/$',v.filter_home, name='filter_home'),
    path('famtree/', v.famtree, name="famtree"),
    path('famtree/sortby=<str:relation>', v.famtree_sort, name="famtree_sort"),
    path('relative/<int:pk>/', v.RelativeDetailView.as_view(), name="relative-detail"),
    path('relative/<int:pk>/edit', v.RelativeUpdateView.as_view(), name="relative-update"),
    path('relative/<int:pk>/delete', v.RelativeDeleteView.as_view(), name="relative-delete"),
    path('relative/<int:pk>/edit/photo', v.relative_photo, name="relative-update-photo"),
    path('relative/<int:pk>/edit/sns', v.relative_sns, name="relative-update-sns"),
    path('photobook/', v.photobook, name="photobook"),
    path('photobook/filter/', v.filter, name="filter_p"),
    re_path(r'^photobook/filter/=(?P<relatives>(?:\d+,*)+)/$',v.filter_photobook, name='filter_photobook'),
    path('help/', v.help, name="help"),
    path('help_dashboard/', v.help_dashboard, name="help_dashboard"),
    path('help_famtree/', v.help_famtree, name="help_famtree"),
    path('help_addpeople/', v.help_addpeople, name="help_addpeople"),
    path('help_album/', v.help_album, name="help_album"),
    path('settings/', v.settings, name="settings"),
    path('settings_profile/', v.settings_profile, name="settings_profile"),
    path('settings_profile/edit', v.settings_profile_edit, name="settings_profile_edit"), # settings edit profile
    path('settings_notification/', v.settings_notification, name="settings_notification"),
    path('settings_privacy/', v.settings_privacy, name="settings_privacy"),
    path('settings_screen/', v.settings_screen, name="settings_screen"),
    path('settings_language/', v.settings_language, name="settings_language"),
    path('settings_app_information/', v.settings_app_information, name="settings_app_information"),
    path('save/post/<str:post_id>/from/<str:sns_tag>/relative/<int:relative_pk>', v.save_post, name="save_post"),
    path('remove/post/<str:post_id>/from/<str:sns_tag>/relative/<int:relative_pk>', v.remove_post, name="remove_post"),
    path('remove/saved_post/<str:post_id>/relative/<int:relative_pk>', v.remove_saved_post, name="remove_saved_post"),
    path('accounts/login/', v.LoginUserView.as_view(), name="login"),
    path('accounts/logout/', LogoutView.as_view(template_name= 'logout.html',next_page= 'login'), name="logout"),

]

sns_integration/models.py
from django import forms
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from phonenumber_field.modelfields import PhoneNumberField

# Create your models here.

# Make sure everything is required!

class UserProfile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    birthday = models.DateField(null=True, blank=True)
    avatar = models.ImageField(upload_to='avatars', blank=True)
    phone_number = PhoneNumberField(null=True, blank=True, unique=False)
    facebook_id = models.CharField(max_length=15,null=True, blank=True) # idk what this is exactly
    twitter_id = models.CharField(max_length=20, null=True, blank=True) # idk what this is exactly
    instagram_id = models.CharField(max_length=20, null=True, blank=True) # idk what this is exactly


class FaceboookProfiles(models.Model):
    fb_id = models.CharField(max_length=15)
    fb_user_token = models.CharField(max_length=220)

    def __str__(self) -> str:
        return self.fb_id

class RelativeProfile(models.Model):
    RELATIONSHIPS = (
        ('D','Daughter'),
        ('S','Son'),
        ('B', "Brother"),
        ('S', "Sister"),
        ('NI','Niece'),
        ('NE','Nephew'),
        ('GD','Granddaughter'),
        ('GS','Grandson'),
        ('C','Cousin'),
        ('F','Father'),
        ('M','Mother'),
        ('GF','Grandfather'),
        ('GM','Grandmother'),
        ('U','Uncle'),
        ('A','Aunt'),
        ('F','Friend'),
    )


    relative = models.ForeignKey(UserProfile, on_delete=models.CASCADE)
    first_name =  models.CharField(max_length=50)
    last_name =  models.CharField(null=True,max_length=50,blank=True)
    birthday = models.DateField(null=True, blank=True,)
    avatar = models.ImageField(upload_to='avatars', blank=True, default='default-avatar.png')
    avatar_url = models.URLField(max_length=1000,blank=True,null=True)
    relation = models.CharField(max_length=2, choices=RELATIONSHIPS)
    facebook_id = models.ForeignKey(FaceboookProfiles, on_delete=models.SET_NULL, null=True,blank=True)
    twitter_id = models.CharField(max_length=20,null=True, blank=True) 
    instagram_id = models.CharField(max_length=20,null=True, blank=True) 


class SavedPosts(models.Model):

    SNS = (
        ('F','facebook'),
        ('I','instagram'),
        ('T','twitter'),
    )

    post_id =  models.CharField(max_length=31)
    sns_tag = models.CharField(max_length=1, choices=SNS)
    saved_date = models.DateField()
    relative = models.ForeignKey(RelativeProfile, on_delete=models.CASCADE)
    created_by = models.ForeignKey(UserProfile, on_delete=models.CASCADE)

class DeletedPosts(models.Model):

    SNS = (
        ('F','facebook'),
        ('I','instagram'),
        ('T','twitter'),
    )

    post_id =  models.CharField(max_length=31)
    sns_tag = models.CharField(max_length=1, choices=SNS)
    saved_date = models.DateField()
    relative = models.ForeignKey(RelativeProfile, on_delete=models.CASCADE)
    created_by = models.ForeignKey(UserProfile, on_delete=models.CASCADE)

def create_profile(sender, **kwargs):
    if kwargs['created']:
        user_profile = UserProfile.objects.create(user=kwargs['instance'])
        # print(kwargs['sender'])

#delete?
#def create_relative(sender, **kwargs):
    #if kwargs['created']:
        #creation = RelativeProfile.objects.create(relative=kwargs['instance'])
    #print(kwargs)
post_save.connect(create_profile, sender=User)
#post_save.connect(create_relative, sender=UserProfile)





sns_integration/views.py
from ast import Continue
import re
from django.contrib.messages.api import success
from django.core.exceptions import PermissionDenied
from django.shortcuts import render, redirect, HttpResponse
import requests
from django.urls import reverse
from django.contrib.auth.views import LoginView
from django.contrib import messages
from django.contrib.auth import login, authenticate
from django.contrib.auth.mixins import UserPassesTestMixin
from django.contrib.auth.decorators import login_required
from django.views.generic.base import RedirectView
from django.views.generic.detail import DetailView
from django.views.generic.edit import DeleteView, UpdateView
from functools import wraps
from django.contrib.auth import REDIRECT_FIELD_NAME
from django.shortcuts import resolve_url
# from django.utils.decorators import available_attrs
from urllib.parse import urlparse

import phonenumbers
from sns_integration.models import DeletedPosts, FaceboookProfiles, SavedPosts
from .forms import *
from config.settings import *
from datetime import datetime

from instagrapi import Client
import twitter
from pyfacebook import GraphAPI


import os
import os.path
import base64
import time

# Create your views here.

#TikTok

#instagram
cl = Client()
#twitter
api = twitter.Api(consumer_key=API_Key,
                      consumer_secret=API_Key_Secret,
                      access_token_key=Access_Token,
                      access_token_secret=Access_Token_Secret,
                      tweet_mode='extended' 
                      )

#convert media to base64
def convertBase64(link):
    if link:
        media_url_og = str(link)
        media_url = base64.b64encode(requests.get(media_url_og).content).decode('utf-8')
        return media_url
    return link

#load facebook test people
def load_test_users():
    user_id = ['263364355631075','108486498291782','101563002392208','105945798609647','108470741689155','108902648311519']
    access_tokens = ['EAACdZC9xZClo4BAJOrQ89Bcz7tk6xGCIAZBOX9kpnamiCy41GXZCBsHy5YNPYG3xg0YXxW2F0cFqGtWKjlaXZAZBTTyzSIIG9rVWKThivUPXIhWZCxIUYcwS2CdHOZBhRhlB396G2wmYZBA6Yyaibrl4nJf1DA0oeVveondR6enGm7iVyCmIZCxQ3f',
                    'EAACdZC9xZClo4BAOX68ZASPyxsK5mghBUAKficQVFTk0IJVSqE5AF22bB6OGsGrAfFj3Mxgsu7et7846exyVk38xKe7ql5ZC2VtCRcQLhIk01rNOpL1xaEmIQnZArKtjBxOPvakjvHEQ0QdZA0081ZB8vkYRpFvwDZAw3hesZABB6AY3ZCCwCa2JzZC',
                    'EAACdZC9xZClo4BAA0ijKFZAd6G4b5MHtnTPZCbvmseDymVeDZA5zsQoBYZCaEFiXeiPE1GCUGmtp7uPptREKDZCNKuPXO6zP8RvSsGYq11trxYIlfo3479gxGg7qxHgiZAxz9QvZBSiiZBGkfksXZAYZBfYJx5bQzjI9g6anTldFkkU4MOKJ035rI1Mg',
                    'EAACdZC9xZClo4BACr7ElZCr7Qyb4I0pUppvwNxnFxN2S63z8ETsuZBpZA17IyjUlexZBSJZBZC5NoOmQPR7qdcuMeHlPcLvUnZChDCwfrLGgwTF6r3ZCVGeAN8EBoheLDFZC3Ry7YTT0rdb0be9AZC9iI9s3qItur6fmNG80s3M8apMZBxut34WAwzKnC',
                    'EAACdZC9xZClo4BAP9HahG9frxxZAtdPGUhvZCrpmpN9YyMPKZABDUyhkGOLzeaNAHL8TJBO7uCxljiKbWZAYgLFowyD6ZBCK1wMUy1zAV66N9ULHoDfPkLwAu4nWG3Tizo9q3pLKnaYsLZCzw6f7MjEic4BTQAswVndyYoaT3T9rV3oy4ect9ElK',
                    'EAACdZC9xZClo4BACYaZBZCa1bngkDmFx2jOF1784koS789ssEnaYLesRAhCKTiMKRipij1dFaIEUuBZAZB4Ub0Q34EgxFFfcsIZAWKnhy7iHuZA6W6uTslRLcELKeugKOk8K4CpttMuwdixmCr1bPJ0ffHh3HtvHW6k3eTeucFRrJKujaay7JwBh']
    for i in range(6):
        FaceboookProfiles.objects.create(fb_id = user_id[i], fb_user_token = access_tokens[i])

class LoginUserView(LoginView):
    template_name= 'sns-integration/login.html'
    def get_success_url(self):
        url = self.get_redirect_url()
        if url:
            return url
        else:
            return reverse("home")

def my_user_passes_test(test_func, login_url=None, redirect_field_name=REDIRECT_FIELD_NAME):
    """
    Decorator for views that checks that the user passes the given test,
    redirecting to the log-in page if necessary. The test should be a callable
    that takes the user object and returns True if the user passes.
    """

    def decorator(view_func):
        @wraps(view_func)
        def _wrapped_view(request, *args, **kwargs):
            # the following line is the only change with respect to
            # user_passes_test:
            if request.user.is_authenticated:
                if test_func(request.user, *args, **kwargs):
                    return view_func(request, *args, **kwargs)
                raise PermissionDenied
            path = request.build_absolute_uri()
            resolved_login_url = resolve_url(login_url or LOGIN_URL)
            # If the login url is the same scheme and net location then just
            # use the path as the "next" url.
            login_scheme, login_netloc = urlparse(resolved_login_url)[:2]
            current_scheme, current_netloc = urlparse(path)[:2]
            if ((not login_scheme or login_scheme == current_scheme) and
                    (not login_netloc or login_netloc == current_netloc)):
                path = request.get_full_path()
            from django.contrib.auth.views import redirect_to_login
            return redirect_to_login(
                path, resolved_login_url, redirect_field_name)
        return _wrapped_view
    return decorator


def user_check(user, **kwargs):
    rel = RelativeProfile.objects.filter(relative = UserProfile.objects.get(user=user))
    for r in rel:
        if kwargs['pk'] == r.pk:
            return True
    return False


class SearchedRedirectView(RedirectView):
    url="index/"

def index(req):
    # print(req.user.email)
    if req.user.is_authenticated:
        return redirect("home")
    else: 
        return render(req, "sns-integration/index.html")
@login_required
def home(req):
    handles =[]
    insta_handles = []
    fb_handles = []
    user = UserProfile.objects.get(user=req.user)
    relatives = user.relativeprofile_set.all()
    for info in relatives:
        if info.twitter_id:
            handles.append(info.twitter_id) 
        if info.instagram_id:
            insta_handles.append(info.instagram_id)
        if info.facebook_id:
            fb_handles.append(info.facebook_id) 
    
            
    print("okay")
    print(handles,insta_handles,fb_handles)
    contents = {"user": req.user,
                "profile": UserProfile.objects.get(user=req.user),
                #"tweets": getTweets(handles),
                #"insta_posts": get_instaPosts(insta_handles),
                'posts': getSnsPosts(handles, insta_handles,fb_handles,user)
                }

    return render(req, 'sns-integration/home.html',contents)
from django.db.models import Count
@login_required
def famtree(req):
    sort = False
    if req.method == "POST":
        if req.POST.getlist("post_categories"):
        #filter = ','.join(map(str, req.POST.getlist("post_categories")))
            return redirect('famtree_sort',relation=str(req.POST.getlist("post_categories")[0]))
    result = []
    users = UserProfile.objects.get(user=req.user)
    relatives = users.relativeprofile_set.all()
    relationships = relatives.values_list('relation', flat=True).distinct()
    for r in relationships:
        if r == '':
            result.append({'short':None,'relation':None})
            continue
        choice = {k: v for k, v in RelativeProfile.RELATIONSHIPS}[r]
        result.append({'short':r,'relation':choice})
    result1 = (relatives
    .values('relation','first_name','last_name','pk','avatar','avatar_url')
    .annotate(dcount=Count('relation'))
    .order_by('relation'))
    for info in result1:
        if info['avatar']:
            info['avatar'] = RelativeProfile.objects.get(pk = int(info['pk']))
    count = relatives.count()
    content = {
        'relatives':result1,
        'count':count,
        'relationships': relationships,
        'relation_display': result,
        'sort':sort
        
    }
    return render(req, 'sns-integration/famtree.html',content)

@login_required
def famtree_sort(req,relation):
    sort = True
    result = []
    users = UserProfile.objects.get(user=req.user)
    relatives = users.relativeprofile_set.all()
    #RelativeProfile.objects.filter(pk__in=relatives)
    relatives_sort = relatives.filter(relation = relation)
    relationships = relatives.values_list('relation', flat=True).distinct()
    if relation not in relationships:
        return redirect('famtree')
    for r in relationships:
        if r == '':
            result.append({'short':None,'relation':None})
            continue
        choice = {k: v for k, v in RelativeProfile.RELATIONSHIPS}[r]
        result.append({'short':r,'relation':choice})
    count = relatives_sort.count()
    content = {
        'relatives':relatives_sort,
        'count':count,
        'relation': relatives_sort[0].get_relation_display(),
        'relationships': relationships,
        'relation_display': result,
        'sort':sort
    }
    return render(req, 'sns-integration/famtree.html',content)

class RelativeDetailView(DetailView,UserPassesTestMixin):
    model = RelativeProfile
    template_name = "sns-integration/relativeprofile_detail.html"

    def test_func(self):
        relative = self.get_object()
        if UserProfile.objects.get(user=self.request.user) == relative.relative:
            return True
        return False

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        twitter_id = context['object'].twitter_id
        instagram_id = context['object'].instagram_id
        if twitter_id:
            t = api.GetUser(user_id=twitter_id)
            context['twitter_handle'] = t.screen_name
        else:
            context['twitter_handle'] = ""
        if instagram_id:
            if os.path.exists(IG_CREDENTIAL_PATH):
                cl.load_settings(IG_CREDENTIAL_PATH)
                cl.login(IG_USERNAME, IG_PASSWORD)

sns_integration/templates/sns-integration/filter.html
<!DOCTYPE html>
{% extends 'base.html' %}
{% load static %}
{% load checkLink %}

{%block links%}
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
    integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
<link rel="stylesheet" type="text/css" href="{% static '/css/general.css' %}" />
<script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"
    integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous">
</script>
{%endblock%}

{% block body %}
<main class="home-body flex-fill">
    <h1>Filter</h1>
    <h3>See specifically from:</h3>
    <br>
    <form {%if pb%} action="{% url 'filter_p' %}" {%else%} action="{% url 'filter' %}" {%endif%} method="POST">
        {% csrf_token %}
        {%for relative in relatives%}
        <label for="checkbox" class="mb-2">
            <input class="form-check-input" value="{{relative.pk}}" type="checkbox" name="checkbox" id="bb1">
            
            <div class="d-inline-block ms-1">
                <!-- {%if relative.avatar_url%}
                <figure class="home_profile_image"><img class="home_profile_actual_image"
                        src="data:image/jpeg;base64,{{relative.avatar_url|base64Images}}" width="30px"></figure>
                {%elif relative.avatar%}
                <figure class="home_profile_image"><img class="home_profile_actual_image" src="{{relative.avatar.url}}"
                        width="30px"></figure>
                {%endif%} -->
                <a style="font-size: 20px;"> {{relative.first_name}} {{relative.last_name}}</a>
                <a style="font-size: 18px; color: #767676;"> {{relative.get_relation_display}}</a>
            </div>
            
            {% if relative.pk == value %}selected="selected"{% endif %}
        </label>
        <br>
        {%endfor%}
        <br>
        <button type="submit" class="btn button-primary" id="sub">Filter chosen relatives</button>
    </form>
    <hr>
</main>
{%endblock%}

sns_integration/templates/sns-integration/help.html
<!DOCTYPE html>
{% extends 'base.html' %} 
{% load static %}

{% block links %}
    <link rel="stylesheet" type="text/css" href="{% static 'css/*.css' %}" />
{% endblock %}

{% block body %}
{% endblock %}

sns_integration/templates/sns-integration/logout.html
<!DOCTYPE html>
{% extends 'base.html' %} 
{% load static %}

{% block links %}
    <link rel="stylesheet" type="text/css" href="{% static 'css/*.css' %}" />
{% endblock %}
<h1>You Logged Out</h1>
{% block body %}
{% endblock %}

sns_integration/templates/sns-integration/register_info2.html
<!DOCTYPE html>

{% load static %}

{% block links %}
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
<link rel="stylesheet" type="text/css" href="{% static '/css/general.css' %}" />
<link rel="stylesheet" type="text/css" href="{% static '/css/onboarding.css' %}" />
<link
     rel="stylesheet"
     href="https://cdnjs.cloudflare.com/ajax/libs/intl-tel-input/17.0.8/css/intlTelInput.css"
   />
   <script src="https://cdnjs.cloudflare.com/ajax/libs/intl-tel-input/17.0.8/js/intlTelInput.min.js"></script>
<script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
{% endblock %}

<!--There two forms here instead of just one.
    detail1_form holds the first and last name and detail2_form - phone_number,birthday 
    I suggest rendering them like this:
    {% for field in detail1_form %} <- change this to detail2_form for phone_number,birthday
        <p >{{ field.label_tag }} </p> <- the label by default generates as the firlds name but with capital letters and removes any underscores
        <p >{{ field }}</p>
        {% if field.errors %} <- this if is the errors
            {% for error in field.errors %}
                <p class="error">{{ error|escape }}</p>
            {% endfor %}
        {% endif %}
    {% endfor %}

    Both forms should still be under just one form tag. If you want to access a specific field they are:
    detail1_form.first_name, detail1_form.last_name, detail2_form.phone_number, detail2_form.birthday-->


{% block body %}
<div class="signup-header">
  <h1 class="text-heading">Step 2/3</h1>
  <h2 class="text-subhead">Some basic information</h2>
</div>
<form method="post" action="{% url 'register_info2' %}">
    {% csrf_token %}
    <!-- {{ detail1_form.as_p }}
    {{ detail2_form.as_p }} -->

    <div id="onboardCarousel" class="carousel slide" data-bs-interval="false">
        
        <div class="carousel-inner">
          <div class="carousel-item active">
            <div class="container">
                <div class="signup-username">
                    <div class="signup-form mt-5">
                        <div class="row g-2">
                            <div class="col">
                            <label for="id_first_name">First Name</label>
                              {{detail1_form.first_name}}
                              <!--<input type="text" name="first_name" maxlength="150" id="id_first_name" class="form-control" placeholder="First name" aria-label="First name">-->
                            </div>
                            <div class="col">
                            <label for="id_last_name">Last Name</label>
                              {{detail1_form.last_name}}
                               <!--<input type="text" name="last_name" maxlength="150" id="id_last_name" class="form-control" placeholder="Last name" aria-label="Last name">-->
                            </div>
                          </div>
                        <span class="helptext">{{detail1_form.first_name.help_text}}</span><br>
                        {% if detail1_form.first_name.errors %}
                          {% for error in detail1_form.first_name.errors %}
                            <p class="error">{{ error|escape }}</p>
                          {% endfor %}
                        {% endif %}
                        <span class="helptext">{{detail1_form.last_name.help_text}}</span><br>
                        {% if detail1_form.last_name.errors %}
                        <div class="alert">
                          {% for error in detail1_form.last_name.errors %}
                            <p class="error">{{ error|escape }}</p>
                          {% endfor %}
                        </div>
                        {% endif %}
                    </div>
                   
                
                 </div>
            </div>
          </div>
          <div class="carousel-item">
              <div class="container justify-content-center">
                <div class="signup-username">
                    <div class="signup-form mt-5">
                        <label for="id_birthday">Date of Birth</label>
                        {{detail2_form.birthday}}
                        <!---<input type="date" name="birthday" id="id_birthday"> -->

                        <span class="helptext">{{detail2_form.birthday.help_text}}</span><br>
                        {% if detail2_form.birthday.errors %}
                        <div class="alert">
                          {% for error in detail2_form.birthday.errors %}
                            <p class="error">{{ error|escape }}</p>
                          {% endfor %}
                          </div>
                        {% endif %}
                    </div>
                  <!-- {{ form.as_p }} -->
                
                 </div>
              </div>
            
          </div>
          <div class="carousel-item">
            <div class="container">
                <div class="signup-username" style="line-height: normal;">
                    <div class="signup-form mt-5">
                        <label for="id_phone_number">Phone Number</label>
                        {{detail2_form.phone_number}}
                        <!--<input type="tel" name="phone_number" maxlength="128" id="id_phone_number" onfocusout="process(event)"> -->
                        <p></p>
                        <span class="helptext">{{detail2_form.phone_number.help_text}}</span><br>
                        {% if detail2_form.phone_number.errors %}
                        <div class="alert">
                          {% for error in detail2_form.phone_number.errors %}
                            <p class="error">{{ error|escape }}</p>
                          {% endfor %}
                        </div>
                        {% endif %}
                    </div>
                    <br>
                    
                    <div class="text-center">
                      <button class="btn button-disabled" type="submit" id="Reg">Register</button>
                    </div>
                    
                  <!-- {{ form.as_p }} -->
                
                
                </div>
              </div>
          </div>
        </div>
        
        <div class="control d-flex justify-content-between">
            <button class="btn button-primary ps-1 invisible" type="button" data-bs-target="#onboardCarousel" data-bs-slide="prev" id="prev"><span class="material-icons">&#xe5cb;</span>Previous</button>
            <button class="btn button-disabled pe-1" type="button" data-bs-target="#onboardCarousel" data-bs-slide="next" id="next">Next<span class="material-icons">&#xe409;</span></button>
            
        </div>
      </div>

    <script>
        var myCarousel = document.querySelector("#onboardCarousel")
        var carousel = new bootstrap.Carousel(myCarousel, {
          interval: false,
          wrap: false
        })
      
        myCarousel.addEventListener('slide.bs.carousel', function (e) {
            if (e.to == 0) {
                $("#prev").addClass("invisible");
            } 
            if (e.to == 1) {
                $("#prev").removeClass("invisible").addClass("visible");
                $('#next').removeClass("d-none").addClass("d-block");
                $('#next').removeClass("button-primary").addClass("button-disabled");
            } 
            if (e.to == 2) {
              $("#prev").removeClass("invisible").addClass("visible");
              $('#next').addClass("d-none");
            } 
          })
          $(document).ready(function() {
            $('#id_first_name, #id_last_name').blur(function()
              {
                  if( !$(this).val() ) {
                      $('#next').removeClass("button-primary").addClass("button-disabled");
                  } else {
                      $('#next').removeClass("button-disabled").addClass("button-primary");
                  }
              });
              

              $('#id_birthday').blur(function()
              {
                  if( !$(this).val() ) {
                      $('#next').removeClass("button-primary").addClass("button-disabled");
                  } else {
                      $('#next').removeClass("button-disabled").addClass("button-primary");
                  }
              });


              $('#id_first_name, #id_last_name, #id_birthday, #id_phone_number').blur(function()
              {
                  if( !$(this).val() ) {
                      $('#Reg').removeClass("button-primary").addClass("button-disabled");
                  } else {
                      $('#Reg').removeClass("button-disabled").addClass("btn-success");
                  }
              });
          });
      </script>
      <script>
        const phoneInputField = document.querySelector("#id_phone_number");
        const phoneInput = window.intlTelInput(phoneInputField, {
          utilsScript:
            "https://cdnjs.cloudflare.com/ajax/libs/intl-tel-input/17.0.8/js/utils.js",
        });

        function process(event) {
          event.preventDefault();

          const phoneNumber = phoneInput.getNumber();

          document.getElementById("id_phone_number").value = phoneNumber;
          }

      </script>
      <script>
        $(document).ready(function(){
          var slide_error = '{{ slide_error }}';
          var slide_error_int = parseInt(slide_error);
          if (slide_error_int =>0){
            $("#onboardCarousel").carousel(slide_error_int);
          }

        });
      </script>
</form>
{% endblock %}